//     TIC8148 alfa 
// :  :  :     ( )
//    ,  
// . RC,    4
//PIN_C3 MODE
//PIN_C4 SET
//PIN_C1     DIN
//PIN_C2  DCLK
//PIN_C0 LOAD
#include <16F630.h>

#FUSES	NOWDT                 	//No Watch Dog Timer
#FUSES	INTRC_IO              	//Internal RC Osc, no CLKOUT
#FUSES	NOPROTECT             	//Code not protected from reading
#FUSES	BROWNOUT              	//Reset when brownout detected
#FUSES	MCLR                  	//Master Clear pin enabled
#FUSES	NOCPD                 	//No EE protection
#FUSES	NOPUT                 	//No Power Up Timer
#rom	0x3FF = {0x3448}
#use	delay(clock=4000000)

#define buf_n 9 //  
unsigned CHAR buf[buf_n];

#define H 8 //    
unsigned CHAR digits[h]; //    ,  .....

#bit  P_1 = 0x36.7// 
#bit  P_2 = 0x35.6
#bit  P_3 = 0x34.5
#bit  P_4 = 0x33.4
#bit  P_5 = 0x32.3
#bit  P_6 = 0x31.2
#bit  P_7 = 0x30.1
#bit  P_8 = 0x2F.0// 

#bit  H_1 = 0x36.6// 
#bit  H_2 = 0x35.5
#bit  H_3 = 0x34.4
#bit  H_4 = 0x33.3
#bit  H_5 = 0x32.2
#bit  H_6 = 0x31.1
#bit  H_7 = 0x30.0
#bit  H_8 = 0x2E.7// 

#define n 5 //  
unsigned CHAR cl[n];// 
#byte	status = 3// 
#bit	C=status.0// 
#byte	TMR0=1// 
int flagi=0b00000001;
#bit  razresh_vyvoda  = flagi.0 //       
#bit  one_millisecond = flagi.1 // 1
#bit  flag01sec       = flagi.2 // 100
#bit  flagNazhatija   = flagi.3 //    
int j=0,l=0;
int i=0,k=0;
int z=0,f=1;
int d=0;
int schet_bitov=0;
int temp=0;
int schetAntidrebezg0=0,schetAntidrebezg1=0,mode=1;
void preobraz_2(void);
	
#int_timer0 
void RTCC_isr(void) 
{ 
TMR0 = TMR0 + 6; 
   //one_millisecond = TRUE;
if(mode==0)
	{ 
	if(++cl[0]==10)// msek
		{
		cl[0]=0; //razresh_vyvoda=1;//   
		if(++cl[1]==100)// msek		
			{
			cl[1]=0;
			if(++cl[2]==60)//sek
				{
				cl[2]=0;
				if(++cl[3]==60)//min
					{
					cl[3]=0;
					if(++cl[4]==24)cl[4]=0;//chas
					}
				}
			}		
		}
	}	   
if(++schetAntidrebezg1==100){flag01sec=1;schetAntidrebezg1=0;}
}
void preobraz(void)
{
l=1;
for(j=0; j < 2; j++){digits[j] = 0;} //
while(l<5)//   , 
	{d=cl[l];l++;//   , ,   .   2-10 
	while (d >= 10)  {d -= 10; ++digits[0];} //
								 digits[1] = d;//
	//   
	preobraz_2();
	for(j=0; j < 2; j++){digits[j] = 0;d=0;} //
	}
}
void preobraz_2(void)//  
{i=2;
while(i>=0){i--;if(i==255)break;// 1  0   digits[i] 
		//       
		shift_left(buf,9,0);//    
		switch(digits[i]){
    				case 0:{temp=0b01111011;}break;//   TIC
    				case 1:{temp=0b01100000;}break;//  
    				case 2:{temp=0b00110111;}break;
    				case 3:{temp=0b01110101;}break;
    				case 4:{temp=0b01101100;}break;
    				case 5:{temp=0b01011101;}break;
    				case 6:{temp=0b01011111;}break;
    				case 7:{temp=0b01110000;}break;
    				case 8:{temp=0b01111111;}break;
    				case 9:{temp=0b01111101;}break;                      
    					}
						for(k=0;k<=7;k++)//   
									{
									shift_left(&temp,1,0);//   temp ()
									shift_left(buf,9,C);
									}
			}
}
void lcd_out(void)//  
{
if(razresh_vyvoda==1)
	{
	preobraz();//preobraz_2();
	    P_3=1;P_5=1;P_7=1;// ,  2  4  
    	//      .
    	if(mode==0)// MODE=0  
	    {
	    if(cl[4]<10){
	    	bit_clear(buf[0],0);
	    	bit_clear(buf[0],1);
	    	bit_clear(buf[0],2);
	    	bit_clear(buf[0],3);
	    	bit_clear(buf[0],4);
	    	bit_clear(buf[0],5);
	    	bit_clear(buf[0],6);}
    		if(++z==15)//  180  
	    		{//  
		    	z=0;
		    	++f;
	    		if(f>8)f=1;
	    		}
		    		
		    		switch(f)
			    		{
						case 1:{H_8=1;}break;
						case 2:{H_7=1;}break;
						case 3:{H_6=1;}break;
						case 4:{H_5=1;}break;
						case 5:{H_4=1;}break;
						case 6:{H_3=1;}break;
						case 7:{H_2=1;}break;
						case 8:{H_1=1;}break;
						}
			}
			if(mode==1)//  
				{
				H_8=1; H_7=1;
				}
			if(mode==2)//  
				{
				H_6=1; H_5=1;
				}	
    }
razresh_vyvoda=0;
if(++schet_bitov<73)//  
	{
	shift_left(buf,9,0);//    
	output_bit(PIN_c1,C);//    DIN
	output_bit(PIN_c2,1);// DCLK=1
	}
else 
	{
    schet_bitov=0;
	output_bit(PIN_c0,1);//LOAD=1
	razresh_vyvoda=1;
	}
output_bit(PIN_c2,0);// DCLK=0
output_bit(PIN_c0,0);//LOAD=0
}

void migalka (void)
{
//      
}

void knopki (void)//  100
{//MODE 0 
 //MODE 1  
 //MODE 2  
 //PIN_C3 MODE
 //PIN_C4 SET
if (input(PIN_C3)||input(PIN_C4))//  SET  MODE
	{
	if(flagNazhatija)//  ?
		{
		if(++schetAntidrebezg0>2)// 
			{
			schetAntidrebezg0=0;
			if(input(PIN_C3))//  MODE
				{
				if(++mode>2)mode=0;//   MODE
				flagNazhatija=1;
				}
			else//  SET
				{
				if(mode==1){if(++cl[4]==24)cl[4]=0;}// 
				if(mode==2){if(++cl[3]==60)cl[3]=0;}// 
				flagNazhatija=1;
				}
			}
		}
	else
		{
		if(input(PIN_C3))//  MODE
			{
			if(++mode>2)mode=0;//   MODE
			flagNazhatija=1;
			}
		else//  SET
			{
			if(mode==1)if(++cl[4]==24)cl[4]=0;// 
			if(mode==2)if(++cl[3]==60)cl[3]=0;// 
			flagNazhatija=1;
			}
		}
	}
else
	{
	flagNazhatija=0;
	}
if(mode!=0){cl[0]=0;cl[1]=0;cl[2]=0;}//   
}
void main(void)
{

	setup_timer_0(RTCC_INTERNAL|RTCC_DIV_4);
	setup_timer_1(T1_DISABLED);
	setup_comparator(NC_NC);
	setup_vref(FALSE);
	enable_interrupts(INT_RTCC);
	enable_interrupts(GLOBAL);
	set_tris_c (7);
	output_c(0);
	for(j=0; j < 5; j++){cl[j] = 0;}
	for(j=0; j < 9; j++){buf[j] = 0;}
	//migalka ();// 

	
while(1)
	{
	lcd_out();
	if(flag01sec){knopki();flag01sec=0;}
	}
}
